Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 100300)
@@ -1883,4 +1883,82 @@
 };
 
+/** Simple action extension, used as 'Perform GoForward' in file manager action class. */
+class UIActionMenuFileManagerGoForward : public UIActionSimple
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs action passing @a pParent to the base-class. */
+    UIActionMenuFileManagerGoForward(UIActionPool *pParent)
+        : UIActionSimple(pParent,
+                         ":/file_manager_go_home_24px.png", ":/file_manager_go_home_16px.png",
+                         ":/file_manager_go_home_disabled_24px.png", ":/file_manager_go_home_disabled_16px.png")
+    {}
+
+protected:
+
+    /** Returns shortcut extra-data ID. */
+    virtual QString shortcutExtraDataID() const RT_OVERRIDE
+    {
+        return QString("FileManagerGoForward");
+    }
+
+    /** Returns default shortcut. */
+    virtual QKeySequence defaultShortcut(UIActionPoolType) const RT_OVERRIDE
+    {
+        return QKeySequence();
+    }
+
+    /** Handles translation event. */
+    virtual void retranslateUi() RT_OVERRIDE
+    {
+        setName(QApplication::translate("UIActionPool", "Go Forward"));
+        setShortcutScope(QApplication::translate("UIActionPool", "File Manager"));
+        setStatusTip(QApplication::translate("UIActionPool", "Go forward"));
+        setToolTip(  QApplication::translate("UIActionPool", "Go Forward")
+                   + (shortcut().isEmpty() ? QString() : QString(" (%1)").arg(shortcut().toString())));
+    }
+};
+
+/** Simple action extension, used as 'Perform GoBackward' in file manager action class. */
+class UIActionMenuFileManagerGoBackward : public UIActionSimple
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs action passing @a pParent to the base-class. */
+    UIActionMenuFileManagerGoBackward(UIActionPool *pParent)
+        : UIActionSimple(pParent,
+                         ":/file_manager_go_home_24px.png", ":/file_manager_go_home_16px.png",
+                         ":/file_manager_go_home_disabled_24px.png", ":/file_manager_go_home_disabled_16px.png")
+    {}
+
+protected:
+
+    /** Returns shortcut extra-data ID. */
+    virtual QString shortcutExtraDataID() const RT_OVERRIDE
+    {
+        return QString("FileManagerGoBackward");
+    }
+
+    /** Returns default shortcut. */
+    virtual QKeySequence defaultShortcut(UIActionPoolType) const RT_OVERRIDE
+    {
+        return QKeySequence();
+    }
+
+    /** Handles translation event. */
+    virtual void retranslateUi() RT_OVERRIDE
+    {
+        setName(QApplication::translate("UIActionPool", "Go Backward"));
+        setShortcutScope(QApplication::translate("UIActionPool", "File Manager"));
+        setStatusTip(QApplication::translate("UIActionPool", "Go forward"));
+        setToolTip(  QApplication::translate("UIActionPool", "Go Backward")
+                   + (shortcut().isEmpty() ? QString() : QString(" (%1)").arg(shortcut().toString())));
+    }
+};
+
 /** Simple action extension, used as 'Perform Delete' in file manager action class. */
 class UIActionMenuFileManagerDelete : public UIActionSimple
@@ -3196,4 +3274,8 @@
     m_pool[UIActionIndex_M_FileManager_S_Host_GoHome] = new UIActionMenuFileManagerGoHome(this);
     m_pool[UIActionIndex_M_FileManager_S_Guest_GoHome] = new UIActionMenuFileManagerGoHome(this);
+    m_pool[UIActionIndex_M_FileManager_S_Host_GoForward] = new UIActionMenuFileManagerGoForward(this);
+    m_pool[UIActionIndex_M_FileManager_S_Guest_GoForward] = new UIActionMenuFileManagerGoForward(this);
+    m_pool[UIActionIndex_M_FileManager_S_Host_GoBackward] = new UIActionMenuFileManagerGoBackward(this);
+    m_pool[UIActionIndex_M_FileManager_S_Guest_GoBackward] = new UIActionMenuFileManagerGoBackward(this);
     m_pool[UIActionIndex_M_FileManager_S_Host_Refresh] = new UIActionMenuFileManagerRefresh(this);
     m_pool[UIActionIndex_M_FileManager_S_Guest_Refresh] = new UIActionMenuFileManagerRefresh(this);
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h	(revision 100300)
@@ -128,4 +128,8 @@
     UIActionIndex_M_FileManager_S_Host_GoHome,
     UIActionIndex_M_FileManager_S_Guest_GoHome,
+    UIActionIndex_M_FileManager_S_Host_GoForward,
+    UIActionIndex_M_FileManager_S_Guest_GoForward,
+    UIActionIndex_M_FileManager_S_Host_GoBackward,
+    UIActionIndex_M_FileManager_S_Guest_GoBackward,
     UIActionIndex_M_FileManager_S_Host_Refresh,
     UIActionIndex_M_FileManager_S_Guest_Refresh,
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.cpp	(revision 100300)
@@ -452,4 +452,6 @@
         connect(m_pNavigationWidget, &UIFileTableNavigationWidget::sigPathChanged,
                 this, &UIFileManagerTable::sltHandleNavigationWidgetPathChange);
+        connect(m_pNavigationWidget, &UIFileTableNavigationWidget::sigHistoryListChanged,
+                this, &UIFileManagerTable::sltHandleNavigationWidgetHistoryListChanged);
         m_pMainLayout->addWidget(m_pNavigationWidget, 1, 1, 1, 6);
         m_sessionWidgets << m_pNavigationWidget;
@@ -639,4 +641,12 @@
 }
 
+void UIFileManagerTable::sltGoForward()
+{
+}
+
+void UIFileManagerTable::sltGoBackward()
+{
+}
+
 void UIFileManagerTable::sltRefresh()
 {
@@ -904,4 +914,11 @@
 {
     goIntoDirectory(UIPathOperations::pathTrail(strPath));
+}
+
+void UIFileManagerTable::sltHandleNavigationWidgetHistoryListChanged()
+{
+    /* Check if forward/backward actions should be disabled/enabled: */
+    int iHistoryListCount = m_pNavigationWidget->historyItemCount();
+    int iCurrentHistoryIndex = m_pNavigationWidget->currentHistoryIndex();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerTable.h	(revision 100300)
@@ -174,4 +174,6 @@
     void sltGoUp();
     void sltGoHome();
+    void sltGoForward();
+    void sltGoBackward();
     void sltRefresh();
     void sltDelete();
@@ -276,4 +278,5 @@
     void sltHandleItemRenameAttempt(UICustomFileSystemItem *pItem, QString strOldName, QString strNewName);
     void sltHandleNavigationWidgetPathChange(const QString& strPath);
+    void sltHandleNavigationWidgetHistoryListChanged();
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserDialog.cpp	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserDialog.cpp	(revision 100300)
@@ -45,4 +45,5 @@
 #endif
 
+/* Other VBox includes: */
 #include <iprt/assert.h>
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoBrowserBase.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoBrowserBase.cpp	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoBrowserBase.cpp	(revision 100300)
@@ -39,4 +39,6 @@
 #include "UIVisoBrowserBase.h"
 
+/* Other VBox includes: */
+#include <iprt/assert.h>
 
 /*********************************************************************************************************************************
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.cpp	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.cpp	(revision 100300)
@@ -241,4 +241,5 @@
         }
         m_pHistoryComboBox->setCurrentIndex(itemIndex);
+        emit sigHistoryListChanged();
     }
 }
@@ -251,4 +252,5 @@
         m_pHistoryComboBox->clear();
         m_pHistoryComboBox->blockSignals(false);
+        emit sigHistoryListChanged();
     }
 
@@ -262,4 +264,18 @@
     if (m_pBreadCrumbs)
         m_pBreadCrumbs->setPathSeparator(m_pathSeparator);
+}
+
+int UIFileTableNavigationWidget::historyItemCount() const
+{
+    if (m_pHistoryComboBox)
+        return 0;
+    return m_pHistoryComboBox->count();
+}
+
+int UIFileTableNavigationWidget::currentHistoryIndex() const
+{
+    if (m_pHistoryComboBox)
+        return 0;
+    return m_pHistoryComboBox->currentIndex();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.h	(revision 100299)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFileTableNavigationWidget.h	(revision 100300)
@@ -52,4 +52,5 @@
 
     void sigPathChanged(const QString &strPath);
+    void sigHistoryListChanged();
 
 public:
@@ -59,4 +60,9 @@
     void reset();
     void setPathSeparator(const QChar &separator);
+    int historyItemCount() const;
+    int currentHistoryIndex() const;
+
+protected:
+
     bool eventFilter(QObject *pObject, QEvent *pEvent) override;
 